/**
 * machine
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * API version: 1
 * 
 *
 */

/* tslint:disable:no-unused-variable member-ordering */

import {AxiosInstance, AxiosResponse}                        from 'axios'

import * as models                                           from '../model/models';
import { COLLECTION_FORMATS }                                from '../variables';
import { Configuration }                                     from '../configuration';
import { Machinecontrollerv1ApiInterface }                            from './Machinecontrollerv1ApiInterface';
import axios                                                 from 'axios';
import {client}                                              from "webstomp-client";


export class Machinecontrollerv1Api implements Machinecontrollerv1ApiInterface {

    protected basePath = 'https://localhost';
    public defaultHeaders: {};
    public configuration: Configuration = new Configuration();

    constructor(protected http: AxiosInstance, configuration?: Configuration) {
        this.basePath = http.defaults.baseURL
        if (configuration) {
            this.configuration = configuration;
        }
    }

    private extendObj<T1, T2 extends T1>(objA: T2, objB: T2): T1|T2 {
        for(let key in objB){
            if(objB.hasOwnProperty(key)){
                objA[key] = objB[key];
            }
        }
        return objA;
    }

    private toQueryString(obj) {
        var parts = [];
        for (var i in obj) {
            if (obj.hasOwnProperty(i)) {
                parts.push(encodeURIComponent(i) + "=" + encodeURIComponent(obj[i]));
            }
        }
        return parts.join("&");
    }

    /**
     * 
     * @summary create
     * @param details details
     */
    public create(details: models.MachineDetails, extraHttpRequestParams?: any): Promise<models.Machine> {
        return new Promise<models.Machine>((resolve, reject) => {
            this.createWithHttpInfo(details, extraHttpRequestParams)
                .then(response => resolve(response.data))
                .catch(reason => reject(reason));
        });
    }

    /**
     * 
     * @summary delete
     * @param machineId machineId
     */
    public delete(machineId: number, extraHttpRequestParams?: any): Promise<{}> {
        return new Promise<{}>((resolve, reject) => {
            this.deleteWithHttpInfo(machineId, extraHttpRequestParams)
                .then(response => resolve(response.data))
                .catch(reason => reject(reason));
        });
    }

    /**
     * 
     * @summary findAggregate
     * @param machineId machineId
     */
    public findAggregate(machineId: number, extraHttpRequestParams?: any): Promise<models.MachineAggregateDto> {
        return new Promise<models.MachineAggregateDto>((resolve, reject) => {
            this.findAggregateWithHttpInfo(machineId, extraHttpRequestParams)
                .then(response => resolve(response.data))
                .catch(reason => reject(reason));
        });
    }

    /**
     * 
     * @summary findAll
     * @param ligneId ligneId
     */
    public findAll(ligneId?: number, extraHttpRequestParams?: any): Promise<Array<models.Machine>> {
        return new Promise<Array<models.Machine>>((resolve, reject) => {
            this.findAllWithHttpInfo(ligneId, extraHttpRequestParams)
                .then(response => resolve(response.data))
                .catch(reason => reject(reason));
        });
    }

    /**
     * 
     * @summary findOne
     * @param machineId machineId
     */
    public findOne(machineId: number, extraHttpRequestParams?: any): Promise<models.Machine> {
        return new Promise<models.Machine>((resolve, reject) => {
            this.findOneWithHttpInfo(machineId, extraHttpRequestParams)
                .then(response => resolve(response.data))
                .catch(reason => reject(reason));
        });
    }

    /**
     * 
     * @summary getState
     * @param machineId machineId
     */
    public getState(machineId: number, extraHttpRequestParams?: any): Promise<string> {
        return new Promise<string>((resolve, reject) => {
            this.getStateWithHttpInfo(machineId, extraHttpRequestParams)
                .then(response => resolve(response.data))
                .catch(reason => reject(reason));
        });
    }

    /**
     * 
     * @summary replace
     * @param machineId machineId
     * @param details details
     */
    public replace(machineId: number, details: models.MachineDetails, extraHttpRequestParams?: any): Promise<models.Machine> {
        return new Promise<models.Machine>((resolve, reject) => {
            this.replaceWithHttpInfo(machineId, details, extraHttpRequestParams)
                .then(response => resolve(response.data))
                .catch(reason => reject(reason));
        });
    }

    /**
     * 
     * @summary update
     * @param machineId machineId
     * @param details details
     */
    public update(machineId: number, details: models.JsonPatch, extraHttpRequestParams?: any): Promise<models.Machine> {
        return new Promise<models.Machine>((resolve, reject) => {
            this.updateWithHttpInfo(machineId, details, extraHttpRequestParams)
                .then(response => resolve(response.data))
                .catch(reason => reject(reason));
        });
    }


    /**
     * create
     * 
     * @param details details
     */
    public createWithHttpInfo(details: models.MachineDetails, extraHttpRequestParams?: any): Promise<AxiosResponse> {
        const path = '/api/v1/machines';

        let queryParameters = {};
        let headers = this.extendObj({}, this.defaultHeaders);;
        // verify required parameter 'details' is not null or undefined
        if (details === null || details === undefined) {
            throw new Error('Required parameter details was null or undefined when calling create.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers['Content-Type'] = 'application/json';


        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters?'?'+queryParameters:'';

        let requestOptions = {
            url: path + queryParameters,
            method: 'post',
            headers: headers,
            baseURL: this.basePath,
            data: details == null ? '' : JSON.stringify(details),
            withCredentials:this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(requestOptions);
    }

    /**
     * delete
     * 
     * @param machineId machineId
     */
    public deleteWithHttpInfo(machineId: number, extraHttpRequestParams?: any): Promise<AxiosResponse> {
        const path = '/api/v1/machines/${machineId}'
                    .replace('${' + 'machineId' + '}', String(machineId));

        let queryParameters = {};
        let headers = this.extendObj({}, this.defaultHeaders);;
        // verify required parameter 'machineId' is not null or undefined
        if (machineId === null || machineId === undefined) {
            throw new Error('Required parameter machineId was null or undefined when calling delete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            '*/*'
        ];


        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters?'?'+queryParameters:'';

        let requestOptions = {
            url: path + queryParameters,
            method: 'delete',
            headers: headers,
            baseURL: this.basePath,
            withCredentials:this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(requestOptions);
    }

    /**
     * findAggregate
     * 
     * @param machineId machineId
     */
    public findAggregateWithHttpInfo(machineId: number, extraHttpRequestParams?: any): Promise<AxiosResponse> {
        const path = '/api/v1/machines/${machineId}/aggregate'
                    .replace('${' + 'machineId' + '}', String(machineId));

        let queryParameters = {};
        let headers = this.extendObj({}, this.defaultHeaders);;
        // verify required parameter 'machineId' is not null or undefined
        if (machineId === null || machineId === undefined) {
            throw new Error('Required parameter machineId was null or undefined when calling findAggregate.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];


        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters?'?'+queryParameters:'';

        let requestOptions = {
            url: path + queryParameters,
            method: 'get',
            headers: headers,
            baseURL: this.basePath,
            withCredentials:this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(requestOptions);
    }

    /**
     * findAll
     * 
     * @param ligneId ligneId
     */
    public findAllWithHttpInfo(ligneId?: number, extraHttpRequestParams?: any): Promise<AxiosResponse> {
        const path = '/api/v1/machines';

        let queryParameters = {};
        let headers = this.extendObj({}, this.defaultHeaders);;
        if (ligneId !== undefined) {
            queryParameters['ligneId'] = ligneId;
        }

        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];


        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters?'?'+queryParameters:'';

        let requestOptions = {
            url: path + queryParameters,
            method: 'get',
            headers: headers,
            baseURL: this.basePath,
            withCredentials:this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(requestOptions);
    }

    /**
     * findOne
     * 
     * @param machineId machineId
     */
    public findOneWithHttpInfo(machineId: number, extraHttpRequestParams?: any): Promise<AxiosResponse> {
        const path = '/api/v1/machines/${machineId}'
                    .replace('${' + 'machineId' + '}', String(machineId));

        let queryParameters = {};
        let headers = this.extendObj({}, this.defaultHeaders);;
        // verify required parameter 'machineId' is not null or undefined
        if (machineId === null || machineId === undefined) {
            throw new Error('Required parameter machineId was null or undefined when calling findOne.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];


        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters?'?'+queryParameters:'';

        let requestOptions = {
            url: path + queryParameters,
            method: 'get',
            headers: headers,
            baseURL: this.basePath,
            withCredentials:this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(requestOptions);
    }

    /**
     * getState
     * 
     * @param machineId machineId
     */
    public getStateWithHttpInfo(machineId: number, extraHttpRequestParams?: any): Promise<AxiosResponse> {
        const path = '/api/v1/machines/${machineId}/etat'
                    .replace('${' + 'machineId' + '}', String(machineId));

        let queryParameters = {};
        let headers = this.extendObj({}, this.defaultHeaders);;
        // verify required parameter 'machineId' is not null or undefined
        if (machineId === null || machineId === undefined) {
            throw new Error('Required parameter machineId was null or undefined when calling getState.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            '*/*'
        ];


        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters?'?'+queryParameters:'';

        let requestOptions = {
            url: path + queryParameters,
            method: 'get',
            headers: headers,
            baseURL: this.basePath,
            withCredentials:this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(requestOptions);
    }

    /**
     * replace
     * 
     * @param machineId machineId
     * @param details details
     */
    public replaceWithHttpInfo(machineId: number, details: models.MachineDetails, extraHttpRequestParams?: any): Promise<AxiosResponse> {
        const path = '/api/v1/machines/${machineId}'
                    .replace('${' + 'machineId' + '}', String(machineId));

        let queryParameters = {};
        let headers = this.extendObj({}, this.defaultHeaders);;
        // verify required parameter 'machineId' is not null or undefined
        if (machineId === null || machineId === undefined) {
            throw new Error('Required parameter machineId was null or undefined when calling replace.');
        }
        // verify required parameter 'details' is not null or undefined
        if (details === null || details === undefined) {
            throw new Error('Required parameter details was null or undefined when calling replace.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers['Content-Type'] = 'application/json';


        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters?'?'+queryParameters:'';

        let requestOptions = {
            url: path + queryParameters,
            method: 'put',
            headers: headers,
            baseURL: this.basePath,
            data: details == null ? '' : JSON.stringify(details),
            withCredentials:this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(requestOptions);
    }

    /**
     * update
     * 
     * @param machineId machineId
     * @param details details
     */
    public updateWithHttpInfo(machineId: number, details: models.JsonPatch, extraHttpRequestParams?: any): Promise<AxiosResponse> {
        const path = '/api/v1/machines/${machineId}'
                    .replace('${' + 'machineId' + '}', String(machineId));

        let queryParameters = {};
        let headers = this.extendObj({}, this.defaultHeaders);;
        // verify required parameter 'machineId' is not null or undefined
        if (machineId === null || machineId === undefined) {
            throw new Error('Required parameter machineId was null or undefined when calling update.');
        }
        // verify required parameter 'details' is not null or undefined
        if (details === null || details === undefined) {
            throw new Error('Required parameter details was null or undefined when calling update.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers['Content-Type'] = 'application/json';


        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters?'?'+queryParameters:'';

        let requestOptions = {
            url: path + queryParameters,
            method: 'patch',
            headers: headers,
            baseURL: this.basePath,
            data: details == null ? '' : JSON.stringify(details),
            withCredentials:this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(requestOptions);
    }

}

    export class Machinecontrollerv1ApiVue extends Machinecontrollerv1Api {

        private installed = false

        constructor() {
            super(axios.create())
        }

        public registerTopicActif(callback: {(message: models.MachineActifEvent): void}): {topic: string, listener: {(message: models.MachineActifEvent): void;}} {
            return {topic: '/topic/machine/v1/state/actif', listener: callback}
        }
        public registerTopicEntity(callback: {(message: models.MachineAggregateEvent): void}): {topic: string, listener: {(message: models.MachineAggregateEvent): void;}} {
            return {topic: '/topic/machine/v1', listener: callback}
        }

        public buildMachineDetails(): models.MachineDetails {
            return {} as models.MachineDetails;
        }
        public buildJsonPatch(): models.JsonPatch {
            return {} as models.JsonPatch;
        }


        private install(Vue, url) {

            if(Vue.topics === undefined) {
                Vue.topics = [];
                Vue.stompConnected = false;
            }

            this.basePath = url

           function addListeners() {
                for(let topic in this.$topics.myTopics) {
                    if(Vue.topics[topic] === undefined) {
                        Vue.topics[topic] = [];
                        tryConnect(function(sessionId) {
                            subscribeTopic(topic);
                        });
                    }
                    let listener = this.$topics.myTopics[topic];
                    Vue.topics[topic][this._uid] = listener;
                }
            }
            function removeListeners() {
                for(let topic in this.$topics.myTopics) {
                    let listener = this.$topics.myTopics[topic];
                    delete Vue.topics[topic][this._uid]
                    if(Vue.topics[topic].join('') === '') {
                        delete Vue.topics[topic];
                        unsubscribeTopic(topic);
                        if(Vue.topics.join('') === '') {
                            tryDisconnect();
                        }
                    }
                }
            }
            function subscribeTopic(topic) {
                console.log('subscribe topic ' + topic);
                Vue.stompClient.subscribe(topic, function(body, headers) {
                    console.log('This is the body of a message on the subscribed queue:', body);
                    Vue.topics[topic].forEach(listener => {
                        listener(body.body);
                    });
                });
            }
            function unsubscribeTopic(topic) {
                console.log('unsubscribe topic ' + topic);
                Vue.stompClient.unsubscribe(topic);
            }
            function tryConnect(callback) {
                if(Vue.stompConnected) {
                    callback(Vue.stompSessionId);
                    return;
                }
                try {
                    Vue.stompClient = client(url.replace('http://', 'ws://') + '/eventsWs');
                } catch(e) {
                    console.log("Impossible de se connecter");
                    console.log(e);
                    setTimeout(function() {
                        tryConnect(function() {
                            for(let topic in Vue.topics) {
                                subscribeTopic(topic);
                            }
                        });
                    }, 2000);
                }
                Vue.stompClient.connect('guest', 'guest', function(sessionId) {
                    Vue.stompSessionId = sessionId;
                    Vue.stompConnected = true;
                    callback(sessionId);
                    console.log('connecté au STOMP ');
                }, function(error) {
                    Vue.stompConnected = false;
                    console.log('Error de connection : ' + error);
                    setTimeout(function() {
                        tryConnect(function() {
                            for(let topic in Vue.topics) {
                                subscribeTopic(topic);
                            }
                        });
                    }, 2000);
                });
            }
            function tryDisconnect() {
                if(!Vue.stompConnected) {
                    return;
                }
                Vue.stompClient.disconnect();
                Vue.stompConnected = false;
            }
            Vue.mixin({
                beforeCreate: function() {
                    this.$topics = {
                        myTopics: {},
                        subscribe: function({topic, listener}) {
                            this.myTopics[topic] = listener;
                        }
                    };
                },
                mounted: addListeners,
                beforeDestroy: removeListeners
            });
        }
    }