import { AxiosInstance, AxiosResponse } from 'axios';
import * as models from '../model/models';
import { Configuration } from '../configuration';
import { Machinecontrollerv1ApiInterface } from './Machinecontrollerv1ApiInterface';
export declare class Machinecontrollerv1Api implements Machinecontrollerv1ApiInterface {
    protected http: AxiosInstance;
    protected basePath: string;
    defaultHeaders: {};
    configuration: Configuration;
    constructor(http: AxiosInstance, configuration?: Configuration);
    private extendObj<T1, T2>(objA, objB);
    private toQueryString(obj);
    create(details: models.MachineDetails, extraHttpRequestParams?: any): Promise<models.Machine>;
    delete(machineId: number, extraHttpRequestParams?: any): Promise<{}>;
    findAggregate(machineId: number, extraHttpRequestParams?: any): Promise<models.MachineAggregateDto>;
    findAll(ligneId?: number, extraHttpRequestParams?: any): Promise<Array<models.Machine>>;
    findOne(machineId: number, extraHttpRequestParams?: any): Promise<models.Machine>;
    getState(machineId: number, extraHttpRequestParams?: any): Promise<string>;
    replace(machineId: number, details: models.MachineDetails, extraHttpRequestParams?: any): Promise<models.Machine>;
    update(machineId: number, details: models.JsonPatch, extraHttpRequestParams?: any): Promise<models.Machine>;
    createWithHttpInfo(details: models.MachineDetails, extraHttpRequestParams?: any): Promise<AxiosResponse>;
    deleteWithHttpInfo(machineId: number, extraHttpRequestParams?: any): Promise<AxiosResponse>;
    findAggregateWithHttpInfo(machineId: number, extraHttpRequestParams?: any): Promise<AxiosResponse>;
    findAllWithHttpInfo(ligneId?: number, extraHttpRequestParams?: any): Promise<AxiosResponse>;
    findOneWithHttpInfo(machineId: number, extraHttpRequestParams?: any): Promise<AxiosResponse>;
    getStateWithHttpInfo(machineId: number, extraHttpRequestParams?: any): Promise<AxiosResponse>;
    replaceWithHttpInfo(machineId: number, details: models.MachineDetails, extraHttpRequestParams?: any): Promise<AxiosResponse>;
    updateWithHttpInfo(machineId: number, details: models.JsonPatch, extraHttpRequestParams?: any): Promise<AxiosResponse>;
}
export declare class Machinecontrollerv1ApiVue extends Machinecontrollerv1Api {
    private installed;
    constructor();
    registerTopicActif(callback: {
        (message: models.MachineActifEvent): void;
    }): {
        topic: string;
        listener: {
            (message: models.MachineActifEvent): void;
        };
    };
    registerTopicEntity(callback: {
        (message: models.MachineAggregateEvent): void;
    }): {
        topic: string;
        listener: {
            (message: models.MachineAggregateEvent): void;
        };
    };
    buildMachineDetails(): models.MachineDetails;
    buildJsonPatch(): models.JsonPatch;
    private install(Vue, url);
}
