"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var configuration_1 = require('../configuration');
var axios_1 = require('axios');
var webstomp_client_1 = require("webstomp-client");
var Machinecontrollerv1Api = (function () {
    function Machinecontrollerv1Api(http, configuration) {
        this.http = http;
        this.basePath = 'https://localhost';
        this.configuration = new configuration_1.Configuration();
        this.basePath = http.defaults.baseURL;
        if (configuration) {
            this.configuration = configuration;
        }
    }
    Machinecontrollerv1Api.prototype.extendObj = function (objA, objB) {
        for (var key in objB) {
            if (objB.hasOwnProperty(key)) {
                objA[key] = objB[key];
            }
        }
        return objA;
    };
    Machinecontrollerv1Api.prototype.toQueryString = function (obj) {
        var parts = [];
        for (var i in obj) {
            if (obj.hasOwnProperty(i)) {
                parts.push(encodeURIComponent(i) + "=" + encodeURIComponent(obj[i]));
            }
        }
        return parts.join("&");
    };
    Machinecontrollerv1Api.prototype.create = function (details, extraHttpRequestParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.createWithHttpInfo(details, extraHttpRequestParams)
                .then(function (response) { return resolve(response.data); })
                .catch(function (reason) { return reject(reason); });
        });
    };
    Machinecontrollerv1Api.prototype.delete = function (machineId, extraHttpRequestParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.deleteWithHttpInfo(machineId, extraHttpRequestParams)
                .then(function (response) { return resolve(response.data); })
                .catch(function (reason) { return reject(reason); });
        });
    };
    Machinecontrollerv1Api.prototype.findAggregate = function (machineId, extraHttpRequestParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.findAggregateWithHttpInfo(machineId, extraHttpRequestParams)
                .then(function (response) { return resolve(response.data); })
                .catch(function (reason) { return reject(reason); });
        });
    };
    Machinecontrollerv1Api.prototype.findAll = function (ligneId, extraHttpRequestParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.findAllWithHttpInfo(ligneId, extraHttpRequestParams)
                .then(function (response) { return resolve(response.data); })
                .catch(function (reason) { return reject(reason); });
        });
    };
    Machinecontrollerv1Api.prototype.findOne = function (machineId, extraHttpRequestParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.findOneWithHttpInfo(machineId, extraHttpRequestParams)
                .then(function (response) { return resolve(response.data); })
                .catch(function (reason) { return reject(reason); });
        });
    };
    Machinecontrollerv1Api.prototype.getState = function (machineId, extraHttpRequestParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.getStateWithHttpInfo(machineId, extraHttpRequestParams)
                .then(function (response) { return resolve(response.data); })
                .catch(function (reason) { return reject(reason); });
        });
    };
    Machinecontrollerv1Api.prototype.replace = function (machineId, details, extraHttpRequestParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.replaceWithHttpInfo(machineId, details, extraHttpRequestParams)
                .then(function (response) { return resolve(response.data); })
                .catch(function (reason) { return reject(reason); });
        });
    };
    Machinecontrollerv1Api.prototype.update = function (machineId, details, extraHttpRequestParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.updateWithHttpInfo(machineId, details, extraHttpRequestParams)
                .then(function (response) { return resolve(response.data); })
                .catch(function (reason) { return reject(reason); });
        });
    };
    Machinecontrollerv1Api.prototype.createWithHttpInfo = function (details, extraHttpRequestParams) {
        var path = '/api/v1/machines';
        var queryParameters = {};
        var headers = this.extendObj({}, this.defaultHeaders);
        ;
        if (details === null || details === undefined) {
            throw new Error('Required parameter details was null or undefined when calling create.');
        }
        var consumes = [
            'application/json'
        ];
        var produces = [
            'application/json'
        ];
        headers['Content-Type'] = 'application/json';
        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters ? '?' + queryParameters : '';
        var requestOptions = {
            url: path + queryParameters,
            method: 'post',
            headers: headers,
            baseURL: this.basePath,
            data: details == null ? '' : JSON.stringify(details),
            withCredentials: this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }
        return this.http.request(requestOptions);
    };
    Machinecontrollerv1Api.prototype.deleteWithHttpInfo = function (machineId, extraHttpRequestParams) {
        var path = '/api/v1/machines/${machineId}'
            .replace('${' + 'machineId' + '}', String(machineId));
        var queryParameters = {};
        var headers = this.extendObj({}, this.defaultHeaders);
        ;
        if (machineId === null || machineId === undefined) {
            throw new Error('Required parameter machineId was null or undefined when calling delete.');
        }
        var consumes = [
            'application/json'
        ];
        var produces = [
            '*/*'
        ];
        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters ? '?' + queryParameters : '';
        var requestOptions = {
            url: path + queryParameters,
            method: 'delete',
            headers: headers,
            baseURL: this.basePath,
            withCredentials: this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }
        return this.http.request(requestOptions);
    };
    Machinecontrollerv1Api.prototype.findAggregateWithHttpInfo = function (machineId, extraHttpRequestParams) {
        var path = '/api/v1/machines/${machineId}/aggregate'
            .replace('${' + 'machineId' + '}', String(machineId));
        var queryParameters = {};
        var headers = this.extendObj({}, this.defaultHeaders);
        ;
        if (machineId === null || machineId === undefined) {
            throw new Error('Required parameter machineId was null or undefined when calling findAggregate.');
        }
        var consumes = [
            'application/json'
        ];
        var produces = [
            'application/json'
        ];
        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters ? '?' + queryParameters : '';
        var requestOptions = {
            url: path + queryParameters,
            method: 'get',
            headers: headers,
            baseURL: this.basePath,
            withCredentials: this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }
        return this.http.request(requestOptions);
    };
    Machinecontrollerv1Api.prototype.findAllWithHttpInfo = function (ligneId, extraHttpRequestParams) {
        var path = '/api/v1/machines';
        var queryParameters = {};
        var headers = this.extendObj({}, this.defaultHeaders);
        ;
        if (ligneId !== undefined) {
            queryParameters['ligneId'] = ligneId;
        }
        var consumes = [
            'application/json'
        ];
        var produces = [
            'application/json'
        ];
        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters ? '?' + queryParameters : '';
        var requestOptions = {
            url: path + queryParameters,
            method: 'get',
            headers: headers,
            baseURL: this.basePath,
            withCredentials: this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }
        return this.http.request(requestOptions);
    };
    Machinecontrollerv1Api.prototype.findOneWithHttpInfo = function (machineId, extraHttpRequestParams) {
        var path = '/api/v1/machines/${machineId}'
            .replace('${' + 'machineId' + '}', String(machineId));
        var queryParameters = {};
        var headers = this.extendObj({}, this.defaultHeaders);
        ;
        if (machineId === null || machineId === undefined) {
            throw new Error('Required parameter machineId was null or undefined when calling findOne.');
        }
        var consumes = [
            'application/json'
        ];
        var produces = [
            'application/json'
        ];
        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters ? '?' + queryParameters : '';
        var requestOptions = {
            url: path + queryParameters,
            method: 'get',
            headers: headers,
            baseURL: this.basePath,
            withCredentials: this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }
        return this.http.request(requestOptions);
    };
    Machinecontrollerv1Api.prototype.getStateWithHttpInfo = function (machineId, extraHttpRequestParams) {
        var path = '/api/v1/machines/${machineId}/etat'
            .replace('${' + 'machineId' + '}', String(machineId));
        var queryParameters = {};
        var headers = this.extendObj({}, this.defaultHeaders);
        ;
        if (machineId === null || machineId === undefined) {
            throw new Error('Required parameter machineId was null or undefined when calling getState.');
        }
        var consumes = [
            'application/json'
        ];
        var produces = [
            '*/*'
        ];
        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters ? '?' + queryParameters : '';
        var requestOptions = {
            url: path + queryParameters,
            method: 'get',
            headers: headers,
            baseURL: this.basePath,
            withCredentials: this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }
        return this.http.request(requestOptions);
    };
    Machinecontrollerv1Api.prototype.replaceWithHttpInfo = function (machineId, details, extraHttpRequestParams) {
        var path = '/api/v1/machines/${machineId}'
            .replace('${' + 'machineId' + '}', String(machineId));
        var queryParameters = {};
        var headers = this.extendObj({}, this.defaultHeaders);
        ;
        if (machineId === null || machineId === undefined) {
            throw new Error('Required parameter machineId was null or undefined when calling replace.');
        }
        if (details === null || details === undefined) {
            throw new Error('Required parameter details was null or undefined when calling replace.');
        }
        var consumes = [
            'application/json'
        ];
        var produces = [
            'application/json'
        ];
        headers['Content-Type'] = 'application/json';
        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters ? '?' + queryParameters : '';
        var requestOptions = {
            url: path + queryParameters,
            method: 'put',
            headers: headers,
            baseURL: this.basePath,
            data: details == null ? '' : JSON.stringify(details),
            withCredentials: this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }
        return this.http.request(requestOptions);
    };
    Machinecontrollerv1Api.prototype.updateWithHttpInfo = function (machineId, details, extraHttpRequestParams) {
        var path = '/api/v1/machines/${machineId}'
            .replace('${' + 'machineId' + '}', String(machineId));
        var queryParameters = {};
        var headers = this.extendObj({}, this.defaultHeaders);
        ;
        if (machineId === null || machineId === undefined) {
            throw new Error('Required parameter machineId was null or undefined when calling update.');
        }
        if (details === null || details === undefined) {
            throw new Error('Required parameter details was null or undefined when calling update.');
        }
        var consumes = [
            'application/json'
        ];
        var produces = [
            'application/json'
        ];
        headers['Content-Type'] = 'application/json';
        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters ? '?' + queryParameters : '';
        var requestOptions = {
            url: path + queryParameters,
            method: 'patch',
            headers: headers,
            baseURL: this.basePath,
            data: details == null ? '' : JSON.stringify(details),
            withCredentials: this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }
        return this.http.request(requestOptions);
    };
    return Machinecontrollerv1Api;
}());
exports.Machinecontrollerv1Api = Machinecontrollerv1Api;
var Machinecontrollerv1ApiVue = (function (_super) {
    __extends(Machinecontrollerv1ApiVue, _super);
    function Machinecontrollerv1ApiVue() {
        _super.call(this, axios_1.default.create());
        this.installed = false;
    }
    Machinecontrollerv1ApiVue.prototype.registerTopicActif = function (callback) {
        return { topic: '/topic/machine/v1/state/actif', listener: callback };
    };
    Machinecontrollerv1ApiVue.prototype.registerTopicEntity = function (callback) {
        return { topic: '/topic/machine/v1', listener: callback };
    };
    Machinecontrollerv1ApiVue.prototype.buildMachineDetails = function () {
        return {};
    };
    Machinecontrollerv1ApiVue.prototype.buildJsonPatch = function () {
        return {};
    };
    Machinecontrollerv1ApiVue.prototype.install = function (Vue, url) {
        if (Vue.topics === undefined) {
            Vue.topics = [];
            Vue.stompConnected = false;
        }
        this.basePath = url;
        function addListeners() {
            var _loop_1 = function(topic) {
                if (Vue.topics[topic] === undefined) {
                    Vue.topics[topic] = [];
                    tryConnect(function (sessionId) {
                        subscribeTopic(topic);
                    });
                }
                var listener = this_1.$topics.myTopics[topic];
                Vue.topics[topic][this_1._uid] = listener;
            };
            var this_1 = this;
            for (var topic in this.$topics.myTopics) {
                _loop_1(topic);
            }
        }
        function removeListeners() {
            for (var topic in this.$topics.myTopics) {
                var listener = this.$topics.myTopics[topic];
                delete Vue.topics[topic][this._uid];
                if (Vue.topics[topic].join('') === '') {
                    delete Vue.topics[topic];
                    unsubscribeTopic(topic);
                    if (Vue.topics.join('') === '') {
                        tryDisconnect();
                    }
                }
            }
        }
        function subscribeTopic(topic) {
            console.log('subscribe topic ' + topic);
            Vue.stompClient.subscribe(topic, function (body, headers) {
                console.log('This is the body of a message on the subscribed queue:', body);
                Vue.topics[topic].forEach(function (listener) {
                    listener(body.body);
                });
            });
        }
        function unsubscribeTopic(topic) {
            console.log('unsubscribe topic ' + topic);
            Vue.stompClient.unsubscribe(topic);
        }
        function tryConnect(callback) {
            if (Vue.stompConnected) {
                callback(Vue.stompSessionId);
                return;
            }
            try {
                Vue.stompClient = webstomp_client_1.client(url.replace('http://', 'ws://') + '/eventsWs');
            }
            catch (e) {
                console.log("Impossible de se connecter");
                console.log(e);
                setTimeout(function () {
                    tryConnect(function () {
                        for (var topic in Vue.topics) {
                            subscribeTopic(topic);
                        }
                    });
                }, 2000);
            }
            Vue.stompClient.connect('guest', 'guest', function (sessionId) {
                Vue.stompSessionId = sessionId;
                Vue.stompConnected = true;
                callback(sessionId);
                console.log('connecté au STOMP ');
            }, function (error) {
                Vue.stompConnected = false;
                console.log('Error de connection : ' + error);
                setTimeout(function () {
                    tryConnect(function () {
                        for (var topic in Vue.topics) {
                            subscribeTopic(topic);
                        }
                    });
                }, 2000);
            });
        }
        function tryDisconnect() {
            if (!Vue.stompConnected) {
                return;
            }
            Vue.stompClient.disconnect();
            Vue.stompConnected = false;
        }
        Vue.mixin({
            beforeCreate: function () {
                this.$topics = {
                    myTopics: {},
                    subscribe: function (_a) {
                        var topic = _a.topic, listener = _a.listener;
                        this.myTopics[topic] = listener;
                    }
                };
            },
            mounted: addListeners,
            beforeDestroy: removeListeners
        });
    };
    return Machinecontrollerv1ApiVue;
}(Machinecontrollerv1Api));
exports.Machinecontrollerv1ApiVue = Machinecontrollerv1ApiVue;
//# sourceMappingURL=Machinecontrollerv1Api.js.map